#ifndef dbtemplate_hdr 
#define dbtemplate_hdr 

/************************************************************
 *                                                          *
 *  dbtemplate.h -                                          *
 *                                                          *
************************************************************/

#include "exc.h"

#define DBMAXARGS 5

#define declare_var(NBARGS) \
   ptr_psi_term psiTerm, args[NBARGS]; \
   ptr_definition types[NBARGS];\
   GENERIC val[NBARGS]; \
   long ii, success=TRUE

#define begin_dbbuiltin(NBARGS,NBARGSTEST) \
     if (NBARGS > DBMAXARGS)  \
       Errorline ("in dbtemplate.h: you have to increase DBMAXARGS at least to %d !\n", NBARGS); \
     psiTerm=aim->a; \
     deref_ptr(psiTerm); \
     deref_args(psiTerm, set_empty); \
     for (ii = 0; success && ii < NBARGS; ii++) \
        success = ( args[ii]=PsiTerm::get_arg(psiTerm, feature[ii]) )?TRUE:FALSE; \
     if (success) \
     { \
	 for (ii = 0; success && ii < NBARGSTEST; ii++) \
	 { \
	    success = (args[ii]->type == types[ii]); \
	    if (success) \
	    {\
	       if (args[ii]->value != NULL) \
		 val[ii] = args[ii]->value; \
	       else \
		 success = FALSE; \
	    }\
	 } \
	 if (success)  \
         {  

#define end_dbbuiltin() \
         } \
	 else \
	   Errorline ("bad arguments in %P.\n", psiTerm); \
     } \
     else \
       Errorline ("missing arguments in %P.\n", psiTerm); \
     return success

#endif
