#include "oid.h"
#include "exc.h"
#include "obj_file.h"

extern "C" {

void check_psi_term(ptr_psi_term*);
void check_bytedata(GENERIC*);

}

ostream& operator<<(ostream& os, const FileKey& f_key){
  f_key.output_data(os);
  return os;
}

void FileKey:: output_data(ostream& os)const{
  os << "(" << "File:" << file_d->name() << ")";
}

////////////////////
// CLASS PageKey //
//////////////////
void PageKey:: output_data(ostream& os)const{
  os << "(" << "Page:" << pnum_d << ")";
}


//////////////////////
// CLASS ObjectKey //
////////////////////
void ObjectKey:: output_data(ostream& os)const{
  os << "(" << "Page: " << pnum_d << ", " << "Slot: " << snum_d << ")";
}

void ObjectId:: check_data() {
  check_bytedata(&dbpointer_d);
}
