#ifndef sql_psi_hdr
#define sql_psi_hdr

#include "OdbSource/psi_term.h"
#include "OdbSource/exc.h"

struct Attribute {

  char *data;
  int sql_type;
  int type; 
  int length; 
  char *col_name;

  REAL data2;

};


class S2P_Value {

public:
  S2P_Value():query_result(NULL),tuple(NULL),num_of_columns(0) {}

  void init() {query_result=NULL;
      delete tuple; num_of_columns=0;}
  void tuple2psi(Attribute* tuple, int num_of_columns);
  ptr_psi_term result() { return query_result; }

private:
  int extract_symbol_from_string(char* str, int len, char* before_hash, 
				 char* after_hash);
  void col2sort(int);

public:
  ptr_psi_term query_result;
  Attribute* tuple;
  int num_of_columns;
};

#endif

